// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UWidgetComponent.h"
#include "SCW_UMeshComponent.h"

class UMeshComponent;
class UWidgetComponent;

namespace Sourcify
{
	class SCW_UWidgetComponent : public SCW_UMeshComponent, public virtual ISCW_UWidgetComponent
	{
	public:
		SCW_UWidgetComponent(UWidgetComponent* InWidgetComponent);

		UWidgetComponent* ToUWidgetComponent() const;

		ISCW_UWidgetComponentPtr ToUWidgetComponentPtr() override;
		ISCW_UWidgetComponentConstPtr ToUWidgetComponentPtr() const override;

	protected:
		UWidgetComponent* WidgetComponent;
	};
} // namespace Sourcify